import discord
import asyncio
import pickle
import time

from funcs import gwendolynFuncs

client = discord.Client()

@client.event
async def on_ready():
    print("Logged in as")
    print(client.user.name)
    print(client.user.id)
    print("-----------")
    game = discord.Game("Some weeb shit")
    await client.change_presence(activity=game)

@client.event
async def on_message(message):
    if message.content.lower().startswith("!help"):
        localtime = time.asctime( time.localtime(time.time()) )
        print("\n"+localtime+"\n"+message.author.name+" ran !help\n")
        file = open("help.txt","r")
        em = discord.Embed(title = "Help", description = file.read(),colour = 0x59f442)
        await message.channel.send(embed = em)

    if message.content.lower().startswith("!hello"):
        localtime = time.asctime( time.localtime(time.time()) )
        print("\n"+localtime+"\n"+message.author.name+" ran !hello")
        await message.channel.send(gwendolynFuncs.helloFunc(message.author.name))

    elif message.content.lower().startswith("!roll"):
        localtime = time.asctime( time.localtime(time.time()) )
        print("\n"+localtime+"\n"+message.author.name+" ran !roll")
        if message.content.lower() == "!roll" or message.content.lower() == "!roll ":
            await message.channel.send(gwendolynFuncs.roll_dice(message.author.name))
        else:
            await message.channel.send(gwendolynFuncs.roll_dice(message.author.name, message.content.lower().replace("!roll","")))

    elif message.content.lower().startswith("!spell "):
        localtime = time.asctime( time.localtime(time.time()) )
        print("\n"+localtime+"\n"+message.author.name+" ran !spell")
        await message.channel.send(gwendolynFuncs.spellFunc(message.content))

    elif message.content.lower().startswith("!monster "):
        localtime = time.asctime( time.localtime(time.time()) )
        print("\n"+localtime+"\n"+message.author.name+" ran !monster")
        title, text1, text2, text3, text4, text5 = gwendolynFuncs.monsterFunc(message.content)
        em1 = discord.Embed(title = title, description = text1, colour=0xDEADBF)
        await message.channel.send(embed = em1)
        if text2 != "":
            if len(text2) < 2048:
                em2 = discord.Embed(title = "Special Abilities", description = text2, colour=0xDEADBF)
                await message.channel.send(embed = em2)
            else:
                em2 = discord.Embed(title = "Special Abilities", description = text2[:2048], colour=0xDEADBF)
                await message.channel.send(embed = em2)
                em2_2 = discord.Embed(title = "", description = text2[2048:], colour=0xDEADBF)
                await message.channel.send(embed = em2_2)
        if text3 != "":
            if len(text3) < 2048:
                em3 = discord.Embed(title = "Actions", description = text3, colour=0xDEADBF)
                await message.channel.send(embed = em3)
            else:
                em3 = discord.Embed(title = "Actions", description = text3[:2048], colour=0xDEADBF)
                await message.channel.send(embed = em3)
                em3_2 = discord.Embed(title = "", description = text3[2048:], colour=0xDEADBF)
                await message.channel.send(embed = em3_2)
        if text4 != "":
            if len(text4) < 2048:
                em4 = discord.Embed(title = "Reactions", description = text4, colour=0xDEADBF)
                await message.channel.send(embed = em4)
            else:
                em4 = discord.Embed(title = "Reactions", description = text4[:2048], colour=0xDEADBF)
                await message.channel.send(embed = em4)
                em4_2 = discord.Embed(title = "", description = text4[2048:], colour=0xDEADBF)
                await message.channel.send(embed = em4_2)
        if text5 != "":
            if len(text5) < 2048:
                em5 = discord.Embed(title = "Legendary Actions", description = text5, colour=0xDEADBF)
                await message.channel.send(embed = em5)
            else:
                em5 = discord.Embed(title = "Legendary Actions", description = text5[:2048], colour=0xDEADBF)
                await message.channel.send(embed = em5)
                em5_2 = discord.Embed(title = "", description = text5[2048:], colour=0xDEADBF)
                await message.channel.send(embed = em5_2)

    elif message.content.lower().startswith("!map"):
        localtime = time.asctime( time.localtime(time.time()) )
        print("\n"+localtime+"\n"+message.author.name+" ran !map")
        await message.channel.send("https://i.imgur.com/diMXXJs.jpg")

    elif message.content.lower().startswith("!image"):
        localtime = time.asctime( time.localtime(time.time()) )
        print("\n"+localtime+"\n"+message.author.name+" ran !image")
        await message.channel.send(gwendolynFuncs.imageFunc())

    elif message.content.lower().startswith("!movie"):
        localtime = time.asctime( time.localtime(time.time()) )
        print("\n"+localtime+"\n"+message.author.name+" ran !movie")
        async with message.channel.typing():
            title, plot, cover, cast = gwendolynFuncs.movieFunc()
            if title == "error":
                await message.channel.send("An error occurred. Try again")
            else:
                embed = discord.Embed(title=title, description=plot, color=0x24ec19)
                embed.set_thumbnail(url=cover)
                embed.add_field(name="Cast", value=cast,inline = True)
                await message.channel.send(embed = embed)

    elif message.content.lower().startswith("!name"):
        localtime = time.asctime( time.localtime(time.time()) )
        print("\n"+localtime+"\n"+message.author.name+" ran !name")
        await message.channel.send(gwendolynFuncs.nameGen())

    elif message.content.lower().startswith("!tavern"):
        localtime = time.asctime( time.localtime(time.time()) )
        print("\n"+localtime+"\n"+message.author.name+" ran !tavern")
        await message.channel.send(gwendolynFuncs.tavernGen())

    elif message.content.lower().startswith("!game "):
        gamePlaying = gwendolynFuncs.cap(message.content.lower().replace("!game ",""))
        localtime = time.asctime( time.localtime(time.time()) )
        print("\n"+localtime+"\n"+message.author.name+" ran !game, changing the game to '"+gamePlaying+"'")
        game = discord.Game(gamePlaying)
        await client.change_presence(activity=game)

    elif message.content.lower().startswith("!swroll"):
        localtime = time.asctime( time.localtime(time.time()) )
        print("\n"+localtime+"\n"+message.author.name+" ran !swroll")
        command = gwendolynFuncs.cap(message.content.lower().replace("!swroll",""))
        await message.channel.send(gwendolynFuncs.parseRoll(message.author.name,command))

    elif message.content.lower().startswith("!swchar"):
        localtime = time.asctime(time.localtime(time.time()))
        print("\n"+localtime+"\n"+message.author.name+" ran !swchar")
        command = gwendolynFuncs.cap(message.content.lower().replace("!swchar",""))
        title, desc = gwendolynFuncs.parseChar(message.author.name,command)
        if title != "":
            em1 = discord.Embed(title = title, description = desc, colour=0xDEADBF)
            await message.channel.send(embed = em1)
        else:
            await message.channel.send(desc)


client.run("MzgwNzI4OTkwMTEwODQyODgx.DO81GQ.rctkEQtieciETXnmsYbwZvvOkaA")

